#include "mdebug.h"
#include "mlib.h"
#include "mstring.h"
#include "mhash.h"
#include "mvector.h"
#include "mlist.h"
#include <stdio.h>

BOOL int_sort_if(void* left, void* right)
{
    return *(int*)left < *(int*)right;
}

int main()
{
    int a, b, c , d, e;

    int* i;

    int j;

    vector_obj*  vector;
    string_obj* str;
    list_obj* list;

    list_it* it;

CHECKML_BEGIN();
LOG_BEGIN();

    a = 1;
    b = 2;
    c = 3;
    d = 4;
    e = 5;
    
    /// vector test ///
    vector = vector_new(10);

    vector_add(vector, &b);
    vector_add(vector, &d);
    vector_add(vector, &a);
    vector_add(vector, &c);
    vector_add(vector, &e);

    for(j=0; j<vector_size(vector); j++) {
        i = vector_item(vector, j);
        printf("%d\n", *i);
    }
    puts("");

    vector_erase(vector, 4);

    vector_sort(vector, int_sort_if);
    
    for(j=0; j<vector_size(vector); j++) {
        i = vector_item(vector, j);
        printf("%d\n", *i);
    }
    
    vector_delete(vector);

    /// string test ///
    str = string_new("abc");

    string_push_back(str, 'd');
    string_push_back(str, 'e');
    string_push_back(str, 'f');

    puts(string_c_str(str));

    string_delete(str);

    /// list test ///
    puts("--- list test ---");
    list = list_new();

    list_push_back(list, &a);

    printf("pop_back %d\n", *(int*)list_pop_back(list));
       
    for(it = list_begin(list); it; it = list_next(it)) {
        int* item = (int*)list_item(it);
        printf("%d\n", *item);
    }
    puts("");
    for(it = list_last(list); it; it = list_prev(it)) {
        int* item = (int*)list_item(it);
        printf("%d\n", *item);
    }
    
    list_delete(list);
   
LOG_END();
CHECKML_END();
   
   return 0;
}
